'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UPDATE_PARAMS = exports.UPDATE_LOCATION = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.locationReducer = locationReducer;
exports.paramsReducer = paramsReducer;
exports.SyncRouting = SyncRouting;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UPDATE_LOCATION = exports.UPDATE_LOCATION = 'UPDATE_LOCATION';
var UPDATE_PARAMS = exports.UPDATE_PARAMS = 'UPDATE_PARAMS';

function locationReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments[1];

  if (action.type === UPDATE_LOCATION) {
    return Object.assign({}, action.payload);
  }
  return state;
}

function paramsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var action = arguments[1];

  if (action.type === UPDATE_PARAMS) {
    return Object.assign({}, action.payload);
  }
  return state;
}

function SyncRouting(ComposedComponent) {
  var Provider = function (_Component) {
    _inherits(Provider, _Component);

    function Provider(props, context) {
      _classCallCheck(this, Provider);

      var _this = _possibleConstructorReturn(this, (Provider.__proto__ || Object.getPrototypeOf(Provider)).call(this, props, context));

      var store = context.store,
          router = context.router;


      store.dispatch({
        type: UPDATE_PARAMS,
        payload: props.params
      });

      store.dispatch({
        type: UPDATE_LOCATION,
        payload: router.location
      });

      function createUniqueKey(location) {
        return router.createPath(location);
      }

      _this.unsubscribeHistory = router.listen(function (nextLocation) {
        var _store$getState = store.getState(),
            location = _store$getState.location;

        if (!location.pathname || createUniqueKey(location) !== createUniqueKey(nextLocation)) {
          store.dispatch({
            type: UPDATE_LOCATION,
            payload: nextLocation
          });
        }
      });
      return _this;
    }

    _createClass(Provider, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        var store = this.context.store;


        if (!(0, _isEqual2.default)(this.props.params, nextProps.params)) {
          store.dispatch({
            type: UPDATE_PARAMS,
            payload: nextProps.params
          });
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.unsubscribeHistory();
      }
    }, {
      key: 'render',
      value: function render() {
        return _react2.default.createElement(ComposedComponent, this.props);
      }
    }]);

    return Provider;
  }(_react.Component);

  Provider.contextTypes = {
    store: _propTypes2.default.object.isRequired,
    router: _propTypes2.default.object.isRequired
  };

  return Provider;
}